Bug 1014209 - (F23PYTHON3) Replace Python 2 with Python 3 in default installation
Replace Python 2 with Python 3 in default installation
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: distribution (Show other bugs)
22
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Miro Hrončok
Fedora Extras Quality Assurance
:
Depends On: PY3PACKAGER 984907 988304 PY3ANACONDA 1014549 1014559 PY3DNF 1014577 1014585 1014589 1014590 1014594 1014595 1023985 1024357 1024359 1024368 1125209 1188215 1192093 1192111 1226879 1227209 1236000 1237118 1238957 1238967 1239016 1241928 1241932 1241947 1241955 1241971 1242076 1244558 1250940 1254566 1257848
Blocks: 1076441
  Show dependency treegraph
 
Reported: 2013-10-01 10:15 EDT by Miro Hrončok
Modified: 2016-07-29 05:13 EDT (History)
17 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-07-19 06:27:15 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Miro Hrončok 2013-10-01 10:15:56 EDT
This is a tracking bug that should cover dropping Python 2 from default installation of Fedora 22 (ideally).

There is a table on the wiki that should cover all packages that need to be updated to Python 3.

https://fedoraproject.org/wiki/User:Churchyard/python3

Currently, this means 3 stacks:

 * DNF
 * Anaconda
 * Other things on Live CD
Comment 1 Stephen Gallagher 2013-10-02 07:42:16 EDT
Miro, please include the component name in the description of all bugs attached to this. Right now, if you look at the dependency tree[1], there are a great many bugs that are just listed as "Support Python 3", which means that you have to click into each one to see which ones are still outstanding. Please make life easier on anyone trying to keep an eye on this and make sure that the summary is more descriptive.
Comment 2 Miro Hrončok 2013-10-02 07:44:50 EDT
Good point, will do. Sorry, this is the first time I've created so many same bug reports.
Comment 3 Kevin Fenzi 2013-10-02 13:59:27 EDT
Please also see: 

http://fedoraproject.org/wiki/Mass_bug_filing

There's a number of things we should do before just filing a bunch of bugs... IMHO.
Comment 4 Toshio Ernie Kuratomi 2013-10-02 14:03:53 EDT
I think this mass filing was too early.  There needs to be an approved Fedora Change before you file these bugs.

In particular, this text is problematic:

"""
Check if upstream already support Python 3, if yes, use it and add te support to the package.

# Needs fesco approval to override the package maintainer.  If the intention is not to override the package maintainer, then the wording should be changed.

If upstream doesn't support Python 3 yet, encourage it to do so by sending patches and offering your help.

# This is good

When upstream is dead or unwilling to support Python 3, you'll need to patch this package on Fedora level. Try to avoid this as much as you can, but use it, if it's the last option.

# This is against the packaging guidelines:
# https://fedoraproject.org/wiki/Packaging:Python#Subpackages
# "Do not build python3 modules without upstream support"
"""

With some rewording to instead say that you're asking packages that can to provide python3 support and packages that can't to be explicit about that so that those can be dropped from the default install this would be much more acceptable.  But now that you've filed the bugs, you'll have to go back and clarify every bug (if that is indeed your intent).
Comment 5 Matthew Miller 2013-10-02 14:24:48 EDT
Assuming the above issues get worked out in some way or another, please don't forget to include cloud-init in this feature.
Comment 6 Miro Hrončok 2013-10-02 15:19:52 EDT
(In reply to Toshio Ernie Kuratomi from comment #4)
> # Needs fesco approval to override the package maintainer.  If the intention
> is not to override the package maintainer, then the wording should be
> changed.

I might not get this. Could you please explain, ho w asking for adding Python 3 support overrides package maintainer?
Comment 7 Toshio Ernie Kuratomi 2013-10-02 15:33:42 EDT
Asking does not.  Making it mandatory does.

"When upstream is dead or unwilling to support Python 3, you'll need to patch this package on Fedora level. Try to avoid this as much as you can, but use it, if it's the last option."

Like I said in comment 4, it could just need rewording.  The present text reads as making it mandatory that package maintainers change their packages to provide python3 subpackages.
Comment 8 Miro Hrončok 2013-10-02 16:56:58 EDT
I admit I made a mistake by filling those bugs without reading the doc. I din't know that such a doc exist. Things in it make point and if I read it before, I would done several thing differently.

However, I believe that if the maintainer is against that, he or she will argue anyway and we can discuss this matter with him/her individually, as for what I see know, most of the maintainers would either do it or say "do it yourself".

And for the against-guidelines upstream unsupported python3 subpackage - I believe we should discuss this further somewhere else - in current state it might be a blocker for this. However I was sometimes encouraged to create such a subpackage (in Package Review process) in the past too.
Comment 9 Toshio Ernie Kuratomi 2013-10-02 17:56:31 EDT
At today's FESCo meeting it was decided that you need to create a Fedora 22 Change that covers this.  https://fedoraproject.org/wiki/Changes/Policy

FESCo wanted it by next week so that we'd be able to tell package maintainers whether this is actually a plan or not.

Putting on my FPC hat, I'm going to have to go to all those bugs and tell them not to follow the package-at-the-Fedora level advice.  If you know what packages you've had reviewed where you deviated from upstream to do this we probably want to split those out into separate packages in F21 and later as well.
Comment 10 Toshio Ernie Kuratomi 2013-10-02 18:46:16 EDT
Also, in doing that I ran across bugs where it didn't appear that the dependency chain had been run down.  For instance, I saw authconfig where it was noted that newt-python would be required and gdb where it was noted that all gdb plugins written in python would need to be updated as well.

(newt seems to have an open bug: https://bugzilla.redhat.com/show_bug.cgi?id=963839  -- You probably want to add that to the blocks py3anaconda tracker as that's where authconfig is.)
Comment 11 Toshio Ernie Kuratomi 2013-10-02 18:49:07 EDT
Also python-pycurl: https://bugzilla.redhat.com/show_bug.cgi?id=1014583
Comment 12 Miro Hrončok 2013-10-12 06:48:44 EDT
Both are the part of the dependency tree on Bugzilla.
Comment 13 Jaroslav Reznik 2015-03-03 11:55:41 EST
This bug appears to have been reported against 'rawhide' during the Fedora 22 development cycle.
Changing version to '22'.

More information and reason for this action is here:
https://fedoraproject.org/wiki/Fedora_Program_Management/HouseKeeping/Fedora22
Comment 14 Nils Philippsen 2015-08-20 05:17:04 EDT
BTW, does this one have to depend on 1014577 (python-paste). I've looked into it and didn't find where DNF, Anaconda, Live CD depend on it.
Comment 15 Robert Kuska 2015-09-07 02:34:46 EDT
Maybe it was added because of the freeipa, but you are right, I can't find any package on WS that depends on python-paste, still having python3 version of python-paste is nice to have as freeipa needs it.
Comment 16 Earth 2015-10-25 07:04:24 EDT
Will Fedora 23 have the helper app that lets you choose version `py -2` or `py -3`?
Comment 17 Fedora End Of Life 2016-07-19 06:27:15 EDT
Fedora 22 changed to end-of-life (EOL) status on 2016-07-19. Fedora 22 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 18 Petr Viktorin 2016-07-29 05:13:09 EDT
Earth, to answer your question (belatedly):
A helper app is unlikely; use python2 or python3.

Note You need to log in before you can comment on or make changes to this bug.